hdu 1208 Pascal's Travels (DP记忆化搜索)

Pascal's Travels

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1115    Accepted Submission(s): 488


Problem Description
An n x n game board is populated with integers, one nonnegative integer per square. The goal is to travel along any legitimate path from the upper left corner to the lower right corner of the board. The integer in any one square dictates how large a step away from that location must be. If the step size would advance travel off the game board, then a step in that particular direction is forbidden. All steps must be either to the right or toward the bottom. Note that a 0 is a dead end which prevents any further progress.


Consider the 4 x 4 board shown in Figure 1, where the solid circle identifies the start position and the dashed circle identifies the target. Figure 2 shows the three paths from the start to the target, with the irrelevant numbers in each removed.


Figure 1


Figure 2


 

Input
The input contains data for one to thirty boards, followed by a final line containing only the integer -1. The data for a board starts with a line containing a single positive integer n, 4 <= n <= 34, which is the number of rows in this board. This is followed by n rows of data. Each row contains n single digits, 0-9, with no spaces between them.


 

Output
The output consists of one line for each board, containing a single integer, which is the number of paths from the upper left corner to the lower right corner. There will be fewer than 2^63 paths for any board.


 

Sample Input
4 2331 1213 1231 3110 4 3332 1213 1232 2120 5 11101 01111 11111 11101 11101 -1


 

Sample Output
3 0 7
Hint
Hint
Brute force methods examining every path will likely exceed the allotted time limit. 64-bit integer values are available as "__int64" values using the Visual C/C++ or "long long" values using GNU C/C++ or "int64" values using Free Pascal compilers.


 

Source


 

Recommend
mcqsmall

思路:没啥好说的,目标点记为1,从开始点开始,走右和下,和加起来即可,具体代码一看便知。

#include<iostream>
#include<cstring>
using namespace std;
const int mm=37;
long long dp[mm][mm];
char f[mm][mm];
bool vis[mm][mm];
int m;
long long DP(int x,int y)
{
  if(x<0||x>=m||y<0||y>=m)return 0;
  if(vis[x][y])return dp[x][y];
  if(f[x][y]=='0')return 0;
  dp[x][y]=DP(x+f[x][y]-'0',y)+DP(x,y+f[x][y]-'0');
  vis[x][y]=1;
  return dp[x][y];
}
int main()
{
  while(cin>>m)
  { if(m==-1)break;
   memset(dp,0,sizeof(dp));
   memset(vis,0,sizeof(vis));
    for(int i=0;i<m;i++)
      {
         cin>>f[i];
      }
      dp[m-1][m-1]=1;vis[m-1][m-1]=1;
    cout<<DP(0,0)<<"\n";
  }
}


 

 

 

posted @ 2013-01-27 10:34  剑不飞  阅读(191)  评论(0编辑  收藏  举报